
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef velodyne_TCLSERV_CLIENT_ERROR_H
#define velodyne_TCLSERV_CLIENT_ERROR_H

#include <server/velodyneError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum velodyne_error {
	E_velodyne_OK					  			= 0,

	/* module errors */
	E_velodyne_BAD_SAVE_PARAMS                = S_velodyne_BAD_SAVE_PARAMS,
	E_velodyne_BAD_TARGET_TRACKING_FILE_OUTPUT_PARAMETER = S_velodyne_BAD_TARGET_TRACKING_FILE_OUTPUT_PARAMETER,
	E_velodyne_BAD_TARGET_TRACKING_PARAMETER  = S_velodyne_BAD_TARGET_TRACKING_PARAMETER,
	E_velodyne_BAD_TARGET_DETECTION_FILE_OUTPUT_PARAMETER = S_velodyne_BAD_TARGET_DETECTION_FILE_OUTPUT_PARAMETER,
	E_velodyne_BAD_SENSOR_TO_MAIN_ANGLES      = S_velodyne_BAD_SENSOR_TO_MAIN_ANGLES,
	E_velodyne_CANNOT_ALLOCATE_IMAGE_3D       = S_velodyne_CANNOT_ALLOCATE_IMAGE_3D,
	E_velodyne_CANNOT_WRITE_ON_FILE           = S_velodyne_CANNOT_WRITE_ON_FILE,
	E_velodyne_CANT_OPEN_FILE                 = S_velodyne_CANT_OPEN_FILE,
	E_velodyne_CAN_NOT_ALLOCATE_MEMORY        = S_velodyne_CAN_NOT_ALLOCATE_MEMORY,
	E_velodyne_CANNOT_UPDATE_TARGET_POSTER    = S_velodyne_CANNOT_UPDATE_TARGET_POSTER,
	E_velodyne_CANNOT_UPDATE_TARGET_TRACKING_POSTER = S_velodyne_CANNOT_UPDATE_TARGET_TRACKING_POSTER,
	E_velodyne_CANNOT_OPEN_FILE               = S_velodyne_CANNOT_OPEN_FILE,
	E_velodyne_CANNOT_CONVERT_T3D             = S_velodyne_CANNOT_CONVERT_T3D,
	E_velodyne_FAILED_TO_ANALYSE_TARGET       = S_velodyne_FAILED_TO_ANALYSE_TARGET,
	E_velodyne_CANNOT_READ_POS_FILE           = S_velodyne_CANNOT_READ_POS_FILE,
	E_velodyne_BAD_3D_IMAGE_SIZE              = S_velodyne_BAD_3D_IMAGE_SIZE,
	E_velodyne_BAD_3D_IMAGE_FILE_FORMAT       = S_velodyne_BAD_3D_IMAGE_FILE_FORMAT,
	E_velodyne_CANNOT_READ_3D_IMAGE_FILE      = S_velodyne_CANNOT_READ_3D_IMAGE_FILE,
	E_velodyne_NUM_PACKETS_EXCEEDS_BUFFER_SIZE = S_velodyne_NUM_PACKETS_EXCEEDS_BUFFER_SIZE,
	E_velodyne_CANNOT_ADD_PACKET              = S_velodyne_CANNOT_ADD_PACKET,
	E_velodyne_CANNOT_OPEN_3D_IMAGE_FILE      = S_velodyne_CANNOT_OPEN_3D_IMAGE_FILE,
	E_velodyne_ACQUISITION_NOT_STARTED        = S_velodyne_ACQUISITION_NOT_STARTED,
	E_velodyne_BAD_ONE_SHOT_PARAMS            = S_velodyne_BAD_ONE_SHOT_PARAMS,
	E_velodyne_NOT_ENOUGH_RESSOURCES          = S_velodyne_NOT_ENOUGH_RESSOURCES,
	E_velodyne_ACQUISITION_ALREADY_STARTED    = S_velodyne_ACQUISITION_ALREADY_STARTED,
	E_velodyne_INTERFACE_NOT_OPEN             = S_velodyne_INTERFACE_NOT_OPEN,
	E_velodyne_BAD_FOV_PARAMS                 = S_velodyne_BAD_FOV_PARAMS,
	E_velodyne_BAD_READ_MODE_PARAMS           = S_velodyne_BAD_READ_MODE_PARAMS,
	E_velodyne_BAD_POS_FILE_FORMAT            = S_velodyne_BAD_POS_FILE_FORMAT,
	E_velodyne_CANNOT_OPEN_POS_FILE           = S_velodyne_CANNOT_OPEN_POS_FILE,
	E_velodyne_CANNOT_READ_POS_POSTER         = S_velodyne_CANNOT_READ_POS_POSTER,
	E_velodyne_CANNOT_FIND_POS_POSTER         = S_velodyne_CANNOT_FIND_POS_POSTER,
	E_velodyne_CANNOT_UPDATE_3D_IMAGE_POSTER  = S_velodyne_CANNOT_UPDATE_3D_IMAGE_POSTER,
	E_velodyne_CANNOT_OPEN_INTERFACE          = S_velodyne_CANNOT_OPEN_INTERFACE,
	E_velodyne_BAD_INIT_PARAMS                = S_velodyne_BAD_INIT_PARAMS,


	/* std errors */
	E_velodyne_ACTIVITY_INTERRUPTED           = S_velodyne_stdGenoM_ACTIVITY_INTERRUPTED,
	E_velodyne_TOO_MANY_ACTIVITIES            = S_velodyne_stdGenoM_TOO_MANY_ACTIVITIES,
	E_velodyne_ACTIVITY_FAILED                = S_velodyne_stdGenoM_ACTIVITY_FAILED,
	E_velodyne_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_velodyne_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_velodyne_UNKNOWN_ACTIVITY               = S_velodyne_stdGenoM_UNKNOWN_ACTIVITY,
	E_velodyne_FORBIDDEN_ACTIVITY_TRANSITION  = S_velodyne_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_velodyne_SYSTEM_ERROR                   = S_velodyne_stdGenoM_SYSTEM_ERROR,
	E_velodyne_ACTIVITY_ALREADY_ENDED         = S_velodyne_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_velodyne_WAIT_INIT_RQST                 = S_velodyne_stdGenoM_WAIT_INIT_RQST,
	E_velodyne_CONTROL_CODEL_ERROR            = S_velodyne_stdGenoM_CONTROL_CODEL_ERROR,
	E_velodyne_EXEC_TASK_SUSPENDED            = S_velodyne_stdGenoM_EXEC_TASK_SUSPENDED,
	E_velodyne_BAD_BLOCK_TYPE                 = S_velodyne_stdGenoM_BAD_BLOCK_TYPE,
	E_velodyne_BAD_POSTER_TYPE                = S_velodyne_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum velodyne_error velodyne_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int velodyne_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the velodyne context.
 *
 * Returns NULL in case of failure
 */
const char* velodyne_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
