
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef velodyne_ERROR_H
#define velodyne_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_velodyne    (5173)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_velodyne_BAD_SAVE_PARAMS      H2_ENCODE_ERR(M_velodyne  , 1)
#define S_velodyne_BAD_TARGET_TRACKING_FILE_OUTPUT_PARAMETER H2_ENCODE_ERR(M_velodyne  , 2)
#define S_velodyne_BAD_TARGET_TRACKING_PARAMETER H2_ENCODE_ERR(M_velodyne  , 3)
#define S_velodyne_BAD_TARGET_DETECTION_FILE_OUTPUT_PARAMETER H2_ENCODE_ERR(M_velodyne  , 4)
#define S_velodyne_BAD_SENSOR_TO_MAIN_ANGLES H2_ENCODE_ERR(M_velodyne  , 5)
#define S_velodyne_CANNOT_ALLOCATE_IMAGE_3D H2_ENCODE_ERR(M_velodyne  , 6)
#define S_velodyne_CANNOT_WRITE_ON_FILE H2_ENCODE_ERR(M_velodyne  , 7)
#define S_velodyne_CANT_OPEN_FILE       H2_ENCODE_ERR(M_velodyne  , 8)
#define S_velodyne_CAN_NOT_ALLOCATE_MEMORY H2_ENCODE_ERR(M_velodyne  , 9)
#define S_velodyne_CANNOT_UPDATE_TARGET_POSTER H2_ENCODE_ERR(M_velodyne  , 10)
#define S_velodyne_CANNOT_UPDATE_TARGET_TRACKING_POSTER H2_ENCODE_ERR(M_velodyne  , 11)
#define S_velodyne_CANNOT_OPEN_FILE     H2_ENCODE_ERR(M_velodyne  , 12)
#define S_velodyne_CANNOT_CONVERT_T3D   H2_ENCODE_ERR(M_velodyne  , 13)
#define S_velodyne_FAILED_TO_ANALYSE_TARGET H2_ENCODE_ERR(M_velodyne  , 14)
#define S_velodyne_CANNOT_READ_POS_FILE H2_ENCODE_ERR(M_velodyne  , 15)
#define S_velodyne_BAD_3D_IMAGE_SIZE    H2_ENCODE_ERR(M_velodyne  , 16)
#define S_velodyne_BAD_3D_IMAGE_FILE_FORMAT H2_ENCODE_ERR(M_velodyne  , 17)
#define S_velodyne_CANNOT_READ_3D_IMAGE_FILE H2_ENCODE_ERR(M_velodyne  , 18)
#define S_velodyne_NUM_PACKETS_EXCEEDS_BUFFER_SIZE H2_ENCODE_ERR(M_velodyne  , 19)
#define S_velodyne_CANNOT_ADD_PACKET    H2_ENCODE_ERR(M_velodyne  , 20)
#define S_velodyne_CANNOT_OPEN_3D_IMAGE_FILE H2_ENCODE_ERR(M_velodyne  , 21)
#define S_velodyne_ACQUISITION_NOT_STARTED H2_ENCODE_ERR(M_velodyne  , 22)
#define S_velodyne_BAD_ONE_SHOT_PARAMS  H2_ENCODE_ERR(M_velodyne  , 23)
#define S_velodyne_NOT_ENOUGH_RESSOURCES H2_ENCODE_ERR(M_velodyne  , 24)
#define S_velodyne_ACQUISITION_ALREADY_STARTED H2_ENCODE_ERR(M_velodyne  , 25)
#define S_velodyne_INTERFACE_NOT_OPEN   H2_ENCODE_ERR(M_velodyne  , 26)
#define S_velodyne_BAD_FOV_PARAMS       H2_ENCODE_ERR(M_velodyne  , 27)
#define S_velodyne_BAD_READ_MODE_PARAMS H2_ENCODE_ERR(M_velodyne  , 28)
#define S_velodyne_BAD_POS_FILE_FORMAT  H2_ENCODE_ERR(M_velodyne  , 29)
#define S_velodyne_CANNOT_OPEN_POS_FILE H2_ENCODE_ERR(M_velodyne  , 30)
#define S_velodyne_CANNOT_READ_POS_POSTER H2_ENCODE_ERR(M_velodyne  , 31)
#define S_velodyne_CANNOT_FIND_POS_POSTER H2_ENCODE_ERR(M_velodyne  , 32)
#define S_velodyne_CANNOT_UPDATE_3D_IMAGE_POSTER H2_ENCODE_ERR(M_velodyne  , 33)
#define S_velodyne_CANNOT_OPEN_INTERFACE H2_ENCODE_ERR(M_velodyne  , 34)
#define S_velodyne_BAD_INIT_PARAMS      H2_ENCODE_ERR(M_velodyne  , 35)


/* std errors */
#define S_velodyne_stdGenoM_ACTIVITY_INTERRUPTED       339076097   /* 5173<<16 | 0x8000 | 100<<8 | 1 */
#define S_velodyne_stdGenoM_TOO_MANY_ACTIVITIES        339076098   /* 5173<<16 | 0x8000 | 100<<8 | 2 */
#define S_velodyne_stdGenoM_ACTIVITY_FAILED            339076099   /* 5173<<16 | 0x8000 | 100<<8 | 3 */
#define S_velodyne_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 339076100   /* 5173<<16 | 0x8000 | 100<<8 | 4 */
#define S_velodyne_stdGenoM_UNKNOWN_ACTIVITY           339076101   /* 5173<<16 | 0x8000 | 100<<8 | 5 */
#define S_velodyne_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 339076102   /* 5173<<16 | 0x8000 | 100<<8 | 6 */
#define S_velodyne_stdGenoM_SYSTEM_ERROR               339076103   /* 5173<<16 | 0x8000 | 100<<8 | 7 */
#define S_velodyne_stdGenoM_ACTIVITY_ALREADY_ENDED     339076104   /* 5173<<16 | 0x8000 | 100<<8 | 8 */
#define S_velodyne_stdGenoM_WAIT_INIT_RQST             339076105   /* 5173<<16 | 0x8000 | 100<<8 | 9 */
#define S_velodyne_stdGenoM_CONTROL_CODEL_ERROR        339076106   /* 5173<<16 | 0x8000 | 100<<8 | 10 */
#define S_velodyne_stdGenoM_EXEC_TASK_SUSPENDED        339076107   /* 5173<<16 | 0x8000 | 100<<8 | 11 */
#define S_velodyne_stdGenoM_BAD_BLOCK_TYPE             339076108   /* 5173<<16 | 0x8000 | 100<<8 | 12 */
#define S_velodyne_stdGenoM_BAD_POSTER_TYPE            339076109   /* 5173<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define VELODYNE_H2_ERR_MSGS {\
    {"BAD_SAVE_PARAMS", 1}, \
    {"BAD_TARGET_TRACKING_FILE_OUTPUT_PARAMETER", 2}, \
    {"BAD_TARGET_TRACKING_PARAMETER", 3}, \
    {"BAD_TARGET_DETECTION_FILE_OUTPUT_PARAMETER", 4}, \
    {"BAD_SENSOR_TO_MAIN_ANGLES", 5}, \
    {"CANNOT_ALLOCATE_IMAGE_3D", 6},\
    {"CANNOT_WRITE_ON_FILE", 7},\
    {"CANT_OPEN_FILE", 8},\
    {"CAN_NOT_ALLOCATE_MEMORY", 9},\
    {"CANNOT_UPDATE_TARGET_POSTER", 10},\
    {"CANNOT_UPDATE_TARGET_TRACKING_POSTER", 11},\
    {"CANNOT_OPEN_FILE", 12},\
    {"CANNOT_CONVERT_T3D", 13},\
    {"FAILED_TO_ANALYSE_TARGET", 14},\
    {"CANNOT_READ_POS_FILE", 15},\
    {"BAD_3D_IMAGE_SIZE", 16},\
    {"BAD_3D_IMAGE_FILE_FORMAT", 17},\
    {"CANNOT_READ_3D_IMAGE_FILE", 18},\
    {"NUM_PACKETS_EXCEEDS_BUFFER_SIZE", 19},\
    {"CANNOT_ADD_PACKET", 20},\
    {"CANNOT_OPEN_3D_IMAGE_FILE", 21},\
    {"ACQUISITION_NOT_STARTED", 22},\
    {"BAD_ONE_SHOT_PARAMS", 23},\
    {"NOT_ENOUGH_RESSOURCES", 24},\
    {"ACQUISITION_ALREADY_STARTED", 25},\
    {"INTERFACE_NOT_OPEN", 26},\
    {"BAD_FOV_PARAMS", 27},\
    {"BAD_READ_MODE_PARAMS", 28},\
    {"BAD_POS_FILE_FORMAT", 29},\
    {"CANNOT_OPEN_POS_FILE", 30},\
    {"CANNOT_READ_POS_POSTER", 31},\
    {"CANNOT_FIND_POS_POSTER", 32},\
    {"CANNOT_UPDATE_3D_IMAGE_POSTER", 33},\
    {"CANNOT_OPEN_INTERFACE", 34},\
    {"BAD_INIT_PARAMS", 35},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int velodyneRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
