
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef velodyne_POSTER_LIB_H
#define velodyne_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "velodyneType.h"
#include "velodyneError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[VELODYNE_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} VELODYNE_CNTRL_STR;

/* For consistency with other posters */
typedef VELODYNE_CNTRL_STR VELODYNE_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "velodynePosterLibStruct.h"



/* Posters */
#define VELODYNE_CNTRL_POSTER_NAME genomInstanceSuffixName("velodyne", "Cntrl")
#define VELODYNE_THREEDIMAGE_POSTER_NAME genomInstanceSuffixName("velodyne", "ThreeDImage")
#define VELODYNE_TARGETABSOLUTEPOSITION_POSTER_NAME genomInstanceSuffixName("velodyne", "TargetAbsolutePosition")
#define VELODYNE_TARGETRELATIVEPOSITION_POSTER_NAME genomInstanceSuffixName("velodyne", "TargetRelativePosition")
#define VELODYNE_TARGETTRACKING_POSTER_NAME genomInstanceSuffixName("velodyne", "TargetTracking")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS velodynePosterInit ( void );
extern POSTER_ID velodyneCntrlPosterID ();
extern STATUS velodyneCntrlPosterRead ( VELODYNE_CNTRL_STR *velodyneCntrlStrId );
extern STATUS velodyneCntrlPosterInit ( void );
extern STATUS velodyneCntrlInstancePosterRead(const char *name, VELODYNE_CNTRL_STR *velodyneCntrlStrId);
extern STATUS velodyneThreeDImagePosterInit ( void );
extern POSTER_ID velodyneThreeDImagePosterID ( void );
extern STATUS velodyneThreeDImagePosterRead ( VELODYNE_THREEDIMAGE_POSTER_STR *x );
extern STATUS velodyneThreeDImageInstancePosterRead ( const char *, VELODYNE_THREEDIMAGE_POSTER_STR * );
extern STATUS velodyneThreeDImagevelodyne3DImagePosterRead ( velodyne3DImage *velodyne3DImage );
extern STATUS velodyneThreeDImagevelodyne3DImageInstancePosterRead( const char *, velodyne3DImage * );
extern STATUS velodyneTargetAbsolutePositionPosterInit ( void );
extern POSTER_ID velodyneTargetAbsolutePositionPosterID ( void );
extern STATUS velodyneTargetAbsolutePositionPosterRead ( VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR *x );
extern STATUS velodyneTargetAbsolutePositionInstancePosterRead ( const char *, VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR * );
extern STATUS velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSPosterRead ( GENPOS_TRAJ_POINTS *GENPOS_TRAJ_POINTS );
extern STATUS velodyneTargetAbsolutePositionGENPOS_TRAJ_POINTSInstancePosterRead( const char *, GENPOS_TRAJ_POINTS * );
extern STATUS velodyneTargetRelativePositionPosterInit ( void );
extern POSTER_ID velodyneTargetRelativePositionPosterID ( void );
extern STATUS velodyneTargetRelativePositionPosterRead ( VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR *x );
extern STATUS velodyneTargetRelativePositionInstancePosterRead ( const char *, VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR * );
extern STATUS velodyneTargetRelativePositionGENPOS_TRAJ_POINTSPosterRead ( GENPOS_TRAJ_POINTS *GENPOS_TRAJ_POINTS );
extern STATUS velodyneTargetRelativePositionGENPOS_TRAJ_POINTSInstancePosterRead( const char *, GENPOS_TRAJ_POINTS * );
extern STATUS velodyneTargetTrackingPosterInit ( void );
extern POSTER_ID velodyneTargetTrackingPosterID ( void );
extern STATUS velodyneTargetTrackingPosterRead ( VELODYNE_TARGETTRACKING_POSTER_STR *x );
extern STATUS velodyneTargetTrackingInstancePosterRead ( const char *, VELODYNE_TARGETTRACKING_POSTER_STR * );
extern STATUS velodyneTargetTrackingGENPOS_TRAJ_POINTSPosterRead ( GENPOS_TRAJ_POINTS *GENPOS_TRAJ_POINTS );
extern STATUS velodyneTargetTrackingGENPOS_TRAJ_POINTSInstancePosterRead( const char *, GENPOS_TRAJ_POINTS * );
#ifdef __cplusplus
}
#endif
#endif

