
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * Sara Fleury
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef VELODYNE_PRINTXML_H
#define VELODYNE_PRINTXML_H

#include "genom/printScan.h"
#include "genom/printXMLProto.h"

/* Structures definies par d'autres modules */

#include "server/genPosPrintXML.h"

#include "server/pomPrintXML.h"


#include "velodynePosterLib.h"

/* Prototypes */
extern void printXML_struct_VELODYNE_TARGETTRACKING_POSTER_STR ( FILE *out, char *name,
     struct VELODYNE_TARGETTRACKING_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR ( FILE *out, char *name,
     struct VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR ( FILE *out, char *name,
     struct VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_VELODYNE_THREEDIMAGE_POSTER_STR ( FILE *out, char *name,
     struct VELODYNE_THREEDIMAGE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_VELODYNE_STR ( FILE *out, char *name,
     struct VELODYNE_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneOneShotParams ( FILE *out, char *name,
     struct velodyneOneShotParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneSaveParams ( FILE *out, char *name,
     struct velodyneSaveParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneTargetTrackingFileOutputParams ( FILE *out, char *name,
     struct velodyneTargetTrackingFileOutputParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneTargetTrackingParams ( FILE *out, char *name,
     struct velodyneTargetTrackingParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneTargetDetectionFileOutput ( FILE *out, char *name,
     struct velodyneTargetDetectionFileOutput *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneTargetDetectionParams ( FILE *out, char *name,
     struct velodyneTargetDetectionParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneTargetParams ( FILE *out, char *name,
     struct velodyneTargetParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_velodyneVerbosity ( FILE *out, char *name,
     enum velodyneVerbosity *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneFOVRemoveLineParams ( FILE *out, char *name,
     struct velodyneFOVRemoveLineParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneFOVRemoveHeadingSectorParams ( FILE *out, char *name,
     struct velodyneFOVRemoveHeadingSectorParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyneInitParams ( FILE *out, char *name,
     struct velodyneInitParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_velodyneModel ( FILE *out, char *name,
     enum velodyneModel *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_velodyneMode ( FILE *out, char *name,
     enum velodyneMode *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_velodyneBoolean ( FILE *out, char *name,
     enum velodyneBoolean *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyne3DImage ( FILE *out, char *name,
     struct velodyne3DImage *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_velodyne3DPoint ( FILE *out, char *name,
     struct velodyne3DPoint *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_velodyne3DPointStatus ( FILE *out, char *name,
     enum velodyne3DPointStatus *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void printXML_velodyne3DPointStatus ( FILE *out, char *name,
     velodyne3DPointStatus *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyne3DPoint ( FILE *out, char *name,
     velodyne3DPoint *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyne3DImage ( FILE *out, char *name,
     velodyne3DImage *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneBoolean ( FILE *out, char *name,
     velodyneBoolean *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneMode ( FILE *out, char *name,
     velodyneMode *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneModel ( FILE *out, char *name,
     velodyneModel *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneInitParams ( FILE *out, char *name,
     velodyneInitParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneFOVRemoveHeadingSectorParams ( FILE *out, char *name,
     velodyneFOVRemoveHeadingSectorParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneFOVRemoveLineParams ( FILE *out, char *name,
     velodyneFOVRemoveLineParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneVerbosity ( FILE *out, char *name,
     velodyneVerbosity *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneTargetParams ( FILE *out, char *name,
     velodyneTargetParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneTargetDetectionParams ( FILE *out, char *name,
     velodyneTargetDetectionParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneTargetDetectionFileOutput ( FILE *out, char *name,
     velodyneTargetDetectionFileOutput *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneTargetTrackingParams ( FILE *out, char *name,
     velodyneTargetTrackingParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneTargetTrackingFileOutputParams ( FILE *out, char *name,
     velodyneTargetTrackingFileOutputParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneSaveParams ( FILE *out, char *name,
     velodyneSaveParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_velodyneOneShotParams ( FILE *out, char *name,
     velodyneOneShotParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_VELODYNE_STR ( FILE *out, char *name,
     VELODYNE_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_VELODYNE_THREEDIMAGE_POSTER_STR ( FILE *out, char *name,
     VELODYNE_THREEDIMAGE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR ( FILE *out, char *name,
     VELODYNE_TARGETABSOLUTEPOSITION_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR ( FILE *out, char *name,
     VELODYNE_TARGETRELATIVEPOSITION_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_VELODYNE_TARGETTRACKING_POSTER_STR ( FILE *out, char *name,
     VELODYNE_TARGETTRACKING_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );

#endif /* VELODYNE_PRINT_XML_H */

